osgGA::StateSetManipulator Class Reference

`#include <StateSetManipulator>`

Inheritance diagram for osgGA::StateSetManipulator:

## Public Member Functions

| StateSetManipulator (osg::StateSet *stateset=0)
virtual const char * | className () const
virtual void | setStateSet (osg::StateSet *)
virtual osg::StateSet * | getStateSet ()
virtual const osg::StateSet * | getStateSet () const
virtual bool | handle (const GUIEventAdapter &ea, GUIActionAdapter &us)
virtual void | getUsage (osg::ApplicationUsage &usage) const
void | setMaximumNumOfTextureUnits (unsigned int i)
unsigned int | getMaximumNumOfTextureUnits () const
void | setBackfaceEnabled (bool newbackface)
bool | getBackfaceEnabled () const
void | setLightingEnabled (bool newlighting)
bool | getLightingEnabled () const
void | setTextureEnabled (bool newtexture)
bool | getTextureEnabled () const
void | setPolygonMode (osg::PolygonMode::Mode newpolygonmode)
osg::PolygonMode::Mode | getPolygonMode () const
void | cyclePolygonMode ()
void | setKeyEventToggleBackfaceCulling (int key)
int | getKeyEventToggleBackfaceCulling () const
void | setKeyEventToggleLighting (int key)
int | getKeyEventToggleLighting () const
void | setKeyEventToggleTexturing (int key)
int | getKeyEventToggleTexturing () const
void | setKeyEventCyclePolygonMode (int key)
int | getKeyEventCyclePolygonMode () const
Public Member Functions inherited from osgGA::GUIEventHandler
| GUIEventHandler ()
| GUIEventHandler (const GUIEventHandler &eh, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgGA, GUIEventHandler)
virtual bool | handle (osgGA::Event *event, osg::Object *object, osg::NodeVisitor *nv)
virtual bool | handle (const GUIEventAdapter &ea, GUIActionAdapter &aa, osg::Object *, osg::NodeVisitor *)
Public Member Functions inherited from osgGA::EventHandler
| EventHandler ()
| EventHandler (const EventHandler &eh, const osg::CopyOp &copyop=osg::CopyOp::SHALLOW_COPY)
| META_Object (osgGA, EventHandler)
virtual NodeCallback * | asNodeCallback ()
virtual const NodeCallback * | asNodeCallback () const
virtual DrawableEventCallback * | asDrawableEventCallback ()
virtual const DrawableEventCallback * | asDrawableEventCallback () const
virtual EventHandler * | asEventHandler ()
virtual const EventHandler * | asEventHandler () const
virtual bool | run (osg::Object *object, osg::Object *data)
virtual void | operator() (osg::Node *node, osg::NodeVisitor *nv)
virtual void | event (osg::NodeVisitor *nv, osg::Drawable *drawable)
Public Member Functions inherited from osg::NodeCallback
| NodeCallback ()
| NodeCallback (const NodeCallback &nc, const CopyOp &copyop)
| META_Object (osg, NodeCallback)
Public Member Functions inherited from osg::Callback
| Callback ()
| Callback (const Callback &cb, const CopyOp &copyop)
| META_Object (osg, Callback)
virtual Callback * | asCallback ()
virtual const Callback * | asCallback () const
virtual CallbackObject * | asCallbackObject ()
virtual const CallbackObject * | asCallbackObject () const
virtual StateAttributeCallback * | asStateAttributeCallback ()
virtual const StateAttributeCallback * | asStateAttributeCallback () const
virtual UniformCallback * | asUniformCallback ()
virtual const UniformCallback * | asUniformCallback () const
virtual DrawableUpdateCallback * | asDrawableUpdateCallback ()
virtual const DrawableUpdateCallback * | asDrawableUpdateCallback () const
virtual DrawableCullCallback * | asDrawableCullCallback ()
virtual const DrawableCullCallback * | asDrawableCullCallback () const
bool | traverse (osg::Object *object, osg::Object *data)
void | setNestedCallback (osg::Callback *cb)
osg::Callback * | getNestedCallback ()
const osg::Callback * | getNestedCallback () const
void | addNestedCallback (osg::Callback *nc)
void | removeNestedCallback (osg::Callback *nc)
Public Member Functions inherited from osg::Object
| Object ()
| Object (bool threadSafeRefUnref)
| Object (const Object &, const CopyOp &copyop=CopyOp::SHALLOW_COPY)
virtual Object * | cloneType () const =0
virtual Object * | clone (const CopyOp &) const =0
virtual bool | isSameKindAs (const Object *) const
virtual const char * | libraryName () const =0
std::string | getCompoundClassName () const
virtual Node * | asNode ()
virtual const Node * | asNode () const
virtual NodeVisitor * | asNodeVisitor ()
virtual const NodeVisitor * | asNodeVisitor () const
virtual StateSet * | asStateSet ()
virtual const StateSet * | asStateSet () const
virtual StateAttribute * | asStateAttribute ()
virtual const StateAttribute * | asStateAttribute () const
virtual Uniform * | asUniform ()
virtual const Uniform * | asUniform () const
virtual Camera * | asCamera ()
virtual const Camera * | asCamera () const
virtual Drawable * | asDrawable ()
virtual const Drawable * | asDrawable () const
virtual UserDataContainer * | asUserDataContainer ()
virtual const UserDataContainer * | asUserDataContainer () const
virtual ValueObject * | asValueObject ()
virtual const ValueObject * | asValueObject () const
virtual Image * | asImage ()
virtual const Image * | asImage () const
virtual void | setThreadSafeRefUnref (bool threadSafe)
virtual void | setName (const std::string &name)
void | setName (const char *name)
const std::string & | getName () const
void | setDataVariance (DataVariance dv)
DataVariance | getDataVariance () const
virtual void | computeDataVariance ()
void | setUserDataContainer (osg::UserDataContainer *udc)
template<class T>
void | setUserDataContainer (const ref_ptr< T > &udc)
osg::UserDataContainer * | getUserDataContainer ()
const osg::UserDataContainer * | getUserDataContainer () const
osg::UserDataContainer * | getOrCreateUserDataContainer ()
virtual void | setUserData (Referenced *obj)
template<class T>
void | setUserData (const ref_ptr< T > &ud)
virtual Referenced * | getUserData ()
virtual const Referenced * | getUserData () const
template<typename T>
bool | getUserValue (const std::string &name, T &value) const
template<typename T>
void | setUserValue (const std::string &name, const T &value)
virtual void | resizeGLObjectBuffers (unsigned int)
virtual void | releaseGLObjects (osg::State *=0) const
template<typename T>
BoolValueObject UCharValueObject UShortValueObject UIntValueObject DoubleValueObject Vec3fValueObject Vec2dValueObject Vec4dValueObject PlaneValueObject MatrixdValueObject BoundingBoxdValueObject BoundingSpheredValueObject bool | getUserValue (const std::string &name, T &value) const
Public Member Functions inherited from osg::Referenced
| Referenced ()
| Referenced (bool threadSafeRefUnref)
| Referenced (const Referenced &)
Referenced & | operator= (const Referenced &)
bool | getThreadSafeRefUnref () const
OpenThreads::Mutex * | getRefMutex () const
int | ref () const
int | unref () const
int | unref_nodelete () const
int | referenceCount () const
ObserverSet * | getObserverSet () const
ObserverSet * | getOrCreateObserverSet () const
void | addObserver (Observer *observer) const
void | removeObserver (Observer *observer) const
Public Member Functions inherited from osg::DrawableEventCallback
| DrawableEventCallback ()
| DrawableEventCallback (const DrawableEventCallback &org, const CopyOp &copyop)
| META_Object (osg, DrawableEventCallback)

## Protected Member Functions

virtual | ~StateSetManipulator ()
void | clone ()
osg::PolygonMode * | getOrCreatePolygonMode ()
Protected Member Functions inherited from osgGA::GUIEventHandler
virtual | ~GUIEventHandler ()
Protected Member Functions inherited from osg::NodeCallback
virtual | ~NodeCallback ()
Protected Member Functions inherited from osg::Callback
virtual | ~Callback ()
Protected Member Functions inherited from osg::Object
virtual | ~Object ()
Protected Member Functions inherited from osg::Referenced
virtual | ~Referenced ()
void | signalObserversAndDelete (bool signalDelete, bool doDelete) const
void | deleteUsingDeleteHandler () const

## Protected Attributes

osg::ref_ptr< osg::StateSet > | _stateset
bool | _initialized
bool | _backface
bool | _lighting
bool | _texture
unsigned int | _maxNumOfTextureUnits
int | _keyEventToggleBackfaceCulling
int | _keyEventToggleLighting
int | _keyEventToggleTexturing
int | _keyEventCyclePolygonMode
Protected Attributes inherited from osg::Callback
ref_ptr< Callback > | _nestedCallback
Protected Attributes inherited from osg::Object
std::string | _name
DataVariance | _dataVariance
osg::UserDataContainer * | _userDataContainer
Protected Attributes inherited from osg::Referenced
OpenThreads::AtomicPtr | _observerSet
OpenThreads::Atomic | _refCount

## Additional Inherited Members

Public Types inherited from osg::Object
enum | DataVariance { DYNAMIC , STATIC , UNSPECIFIED }
Static Public Member Functions inherited from osg::Referenced
static OpenThreads::Mutex * | getGlobalReferencedMutex ()
static void | setDeleteHandler (DeleteHandler *handler)
static DeleteHandler * | getDeleteHandler ()

## Detailed Description

Experimental class, not been looked at for a while, but which will be returned to at some point :-\

## Constructor & Destructor Documentation

## StateSetManipulator()

osgGA::StateSetManipulator::StateSetManipulator | ( | osg::StateSet * | stateset = 0 | ) |

## ~StateSetManipulator()

virtual osgGA::StateSetManipulator::~StateSetManipulator | ( |  | ) |

protected virtual

## Member Function Documentation

## className()

virtual const char * osgGA::StateSetManipulator::className | ( |  | ) | const

inline virtual

return the name of the object's class type. Must be defined by derived classes.

Implements osg::Object.

## clone()

void osgGA::StateSetManipulator::clone | ( |  | ) |

protected

## cyclePolygonMode()

void osgGA::StateSetManipulator::cyclePolygonMode | ( |  | ) |

## getBackfaceEnabled()

bool osgGA::StateSetManipulator::getBackfaceEnabled | ( |  | ) | const

inline

References _backface.

## getKeyEventCyclePolygonMode()

int osgGA::StateSetManipulator::getKeyEventCyclePolygonMode | ( |  | ) | const

inline

References _keyEventCyclePolygonMode.

## getKeyEventToggleBackfaceCulling()

int osgGA::StateSetManipulator::getKeyEventToggleBackfaceCulling | ( |  | ) | const

inline

References _keyEventToggleBackfaceCulling.

## getKeyEventToggleLighting()

int osgGA::StateSetManipulator::getKeyEventToggleLighting | ( |  | ) | const

inline

References _keyEventToggleLighting.

## getKeyEventToggleTexturing()

int osgGA::StateSetManipulator::getKeyEventToggleTexturing | ( |  | ) | const

inline

References _keyEventToggleTexturing.

## getLightingEnabled()

bool osgGA::StateSetManipulator::getLightingEnabled | ( |  | ) | const

inline

References _lighting.

## getMaximumNumOfTextureUnits()

unsigned int osgGA::StateSetManipulator::getMaximumNumOfTextureUnits | ( |  | ) | const

inline

References _maxNumOfTextureUnits.

## getOrCreatePolygonMode()

osg::PolygonMode * osgGA::StateSetManipulator::getOrCreatePolygonMode | ( |  | ) |

protected

## getPolygonMode()

osg::PolygonMode::Mode osgGA::StateSetManipulator::getPolygonMode | ( |  | ) | const

## getStateSet() [1/2]

virtual osg::StateSet * osgGA::StateSetManipulator::getStateSet | ( |  | ) |

virtual

get the attached a StateSet.

## getStateSet() [2/2]

virtual const osg::StateSet * osgGA::StateSetManipulator::getStateSet | ( |  | ) | const

virtual

get the attached a StateSet.

## getTextureEnabled()

bool osgGA::StateSetManipulator::getTextureEnabled | ( |  | ) | const

inline

References _texture.

## getUsage()

virtual void osgGA::StateSetManipulator::getUsage | ( | osg::ApplicationUsage & | usage | ) | const

virtual

Get the keyboard and mouse usage of this manipulator.

Reimplemented from osgGA::EventHandler.

## handle()

virtual bool osgGA::StateSetManipulator::handle | ( | const GUIEventAdapter & | ea,
|  | GUIActionAdapter & | us )

virtual

Handle events, return true if handled, false otherwise.

Reimplemented from osgGA::GUIEventHandler.

## setBackfaceEnabled()

void osgGA::StateSetManipulator::setBackfaceEnabled | ( | bool | newbackface | ) |

## setKeyEventCyclePolygonMode()

void osgGA::StateSetManipulator::setKeyEventCyclePolygonMode | ( | int | key | ) |

inline

References _keyEventCyclePolygonMode.

## setKeyEventToggleBackfaceCulling()

void osgGA::StateSetManipulator::setKeyEventToggleBackfaceCulling | ( | int | key | ) |

inline

References _keyEventToggleBackfaceCulling.

## setKeyEventToggleLighting()

void osgGA::StateSetManipulator::setKeyEventToggleLighting | ( | int | key | ) |

inline

References _keyEventToggleLighting.

## setKeyEventToggleTexturing()

void osgGA::StateSetManipulator::setKeyEventToggleTexturing | ( | int | key | ) |

inline

References _keyEventToggleTexturing.

## setLightingEnabled()

void osgGA::StateSetManipulator::setLightingEnabled | ( | bool | newlighting | ) |

## setMaximumNumOfTextureUnits()

void osgGA::StateSetManipulator::setMaximumNumOfTextureUnits | ( | unsigned int | i | ) |

inline

References _maxNumOfTextureUnits.

## setPolygonMode()

void osgGA::StateSetManipulator::setPolygonMode | ( | osg::PolygonMode::Mode | newpolygonmode | ) |

## setStateSet()

virtual void osgGA::StateSetManipulator::setStateSet | ( | osg::StateSet * |  | ) |

virtual

attach a StateSet to the manipulator to be used for specifying view.

## setTextureEnabled()

void osgGA::StateSetManipulator::setTextureEnabled | ( | bool | newtexture | ) |

## Member Data Documentation

## _backface

bool osgGA::StateSetManipulator::_backface

protected

Referenced by getBackfaceEnabled().

## _initialized

bool osgGA::StateSetManipulator::_initialized

protected

## _keyEventCyclePolygonMode

int osgGA::StateSetManipulator::_keyEventCyclePolygonMode

protected

Referenced by getKeyEventCyclePolygonMode(), and setKeyEventCyclePolygonMode().

## _keyEventToggleBackfaceCulling

int osgGA::StateSetManipulator::_keyEventToggleBackfaceCulling

protected

Referenced by getKeyEventToggleBackfaceCulling(), and setKeyEventToggleBackfaceCulling().

## _keyEventToggleLighting

int osgGA::StateSetManipulator::_keyEventToggleLighting

protected

Referenced by getKeyEventToggleLighting(), and setKeyEventToggleLighting().

## _keyEventToggleTexturing

int osgGA::StateSetManipulator::_keyEventToggleTexturing

protected

Referenced by getKeyEventToggleTexturing(), and setKeyEventToggleTexturing().

## _lighting

bool osgGA::StateSetManipulator::_lighting

protected

Referenced by getLightingEnabled().

## _maxNumOfTextureUnits

unsigned int osgGA::StateSetManipulator::_maxNumOfTextureUnits

protected

Referenced by getMaximumNumOfTextureUnits(), and setMaximumNumOfTextureUnits().

## _stateset

osg::ref_ptr<osg::StateSet> osgGA::StateSetManipulator::_stateset

protected

## _texture

bool osgGA::StateSetManipulator::_texture

protected

Referenced by getTextureEnabled().

The documentation for this class was generated from the following file:

- StateSetManipulator